unit PhoneBookFrame;
// (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExButtons;

type
  TPhoneBook = class(TFrame)
    Call: TButton;
    Change: TButton;
    Del: TButton;
    List: TListBox;
    Number: TEdit;
    Add: TButton;
    procedure NumberKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure NumberKeyPress(Sender: TObject; var Key: Char);
    procedure ListClick(Sender: TObject);
    procedure CallClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure ChangeClick(Sender: TObject);
    procedure DelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Book:string;      // Ini Section for PhoneBook
    procedure ReadPhoneBook;
  end;

implementation

uses main, SIP;

{$R *.dfm}

procedure TPhoneBook.NumberKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
 i:integer;
begin
 case Key of
  VK_UP   : i:=-1;
  VK_DOWN : i:=+1;
  else exit;
 end;
 inc(i,List.ItemIndex);
 if i<0 then i:=List.Count-1 else
 if i>=List.Count then begin
  if i=0 then exit;
  i:=0;
 end;
 List.ItemIndex:=i;
 ListClick(Self);
 Key:=0;
end;

procedure TPhoneBook.NumberKeyPress(Sender: TObject; var Key: Char);
begin
 case Key of
  #13: CallClick(Self);
  else exit;
 end;
 Key:=#0;
end;

procedure TPhoneBook.ListClick(Sender: TObject);
var
 i:integer;
begin
 i:=List.ItemIndex;
 if i<0 then exit;
 Number.Text:=MainForm.Ini.ReadString(Book,List.Items[i],'');
end;

procedure TPhoneBook.CallClick(Sender: TObject);
var
 s:string;
begin
 if MainForm.SIP.Step<>csREGISTERED then begin
  ShowMessage('Veuillez d''abord vous connecter au service SIP');
  exit;
 end;
 s:=Number.Text;
 if s='' then exit;
 MainForm.Dial(s);
end;

procedure TPhoneBook.AddClick(Sender: TObject);
begin
 Hide;
 MainForm.PhoneBookEntry.Add;
end;

procedure TPhoneBook.ChangeClick(Sender: TObject);
var
 i:integer;
 s:string;
begin
 i:=List.ItemIndex;
 if i<0 then exit;
 s:=List.Items[i];
 Hide;
 MainForm.PhoneBookEntry.Edit(s,MainForm.Ini.ReadString(Book,s,''));
end;

procedure TPhoneBook.DelClick(Sender: TObject);
var
 i:integer;
 s:string;
begin
 i:=List.ItemIndex;
 if i<0 then exit;
 s:=List.Items[i];
 if MessageDlg('Voulez-vous supprimer '+s+' ?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
 MainForm.Ini.DeleteKey(Book,s);
 List.Items.Delete(i);
end;

procedure TPhoneBook.ReadPhoneBook;
begin
 Book:=MainForm.UserID.Text+'.Phones';
 MainForm.Ini.ReadSection(Book,List.Items);
end;

end.

